from Products.Archetypes.public import *

    


class BatyMateriel(BaseContent,):
    portal_type = meta_type = 'BatyMateriel' 
    archetype_name = 'BatyMateriel'   #this name appears in the 'add' box 
    schema=BaseSchema + Schema((
         # StringField('title',
#                     searchable=1,
#                      widget=StringWidget(description='Rentrez le nom de l\'article',label='Nom'),
#                     ),
          StringField('description',
                     searchable=1,
                      widget=TextAreaWidget(format=1,description='Rentrez la description de l\'article', label='Description'),
                     ),
         
         StringField('unite',
                     vocabulary="getListUnite",
                     searchable=1,
                     widget=SelectionWidget(format="select",label='Unite',description='Rentrez l\'unit du materiel', macro="macro_selection"),
                    ),
         StringField('code_frais_structure',
                     vocabulary="getCoef_structure",
                    searchable=1,
                     widget=SelectionWidget(format="select",description='Rentrez le coeficient de structure' ,label='Coeficient de structure', macro="macro_selection"),
                    ),
         FloatField('prix_de_revient',
                    searchable=1,
                    validators=('isDecimal',),
                    widget=DecimalWidget(size="25",description='Prix de revient du matriel',label="Prix de revient",macro="macro_euro")
                    
                    ),
         FloatField('prix_de_location',
                    searchable=1,
                    validators=('isDecimal',),
                    widget=DecimalWidget(size="25",description='Prix de location du matriel',label="Prix de location",macro="macro_euro"),
                    ),
         BooleanField('en_entreprise',
                    searchable=1,
                    
                    widget=BooleanWidget(description='Disponible dans l\'entreprise',label="Appareil entreprise"),
                   
                    
                    ),
          
         StringField('code_comptable',
                    #searchable=1,
                     vocabulary= "getListCodeComptable",
                    widget=SelectionWidget(format="select", label="Code comptable", description ="Code comptable de l'article",macro="macro_selection"),   
                    ),

    ))

    #Methods
        
        
    factory_type_information={
        'allowed_content_types':(),
        #'content_icon':'BatyArticle.gif',
        'immediate_view':'base_view'
        }

        
registerType(BatyMateriel)# end class BatyArticle


