##retourne la liste des articles contenu dans un devis
##parameters=context_obj=None

if context_obj is None:
    context_obj=context
list_obj=context_obj.objectValues('BatyLigneProduit')

coef_vente=context_obj.getParentNode().getCoefficient_vente()
coef_marge=context_obj.getParentNode().getCoefficient_marge()
coef_tva=context_obj.getParentNode().getCoefficient_tva()




return [{'id':obj.getId(),
         'Title':obj.Title(),
         'Description':obj.Description(),
         'unite':obj.getUnite(),
         'quantite':obj.getQuantite(),
         'prix_achat':"%.2f" % (obj.getPrixAchat()*obj.getQuantite(),),
         'prix_revient': "%.2f" % ( obj.getPrix()*obj.getQuantite(),),
         'coef': "%.2f" % (coef_vente,),
         'prix_vente':"%.2f" % (obj.getPrix()*obj.getQuantite()*(1+coef_vente/100)),
         'tva': "%.2f" % (coef_tva),
         'total':"%.2f" % (obj.getPrix()*obj.getQuantite()*(1+coef_vente/100)*(1+coef_tva/100),)} for obj in list_obj ]
