#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase

class TestBase(BatyTestCase.BatyTestCase):

    
        

    def testFolderEntreprise(self):
        
        self.failUnless(hasattr(self.portal,'Entreprises'))

    def testBaseArticle(self):
        
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'base_article') and len(self.portal.Entreprises.test_baty.base_article.objectIds(['BatyArticleFraisStockage']))==len(self.portal.Entreprises.test_baty.Configuration.objectIds(['BatyCoefficientStockage'])) and len(self.portal.Entreprises.test_baty.base_article.objectIds(['BatyArticleFraisGeneraux']))==len(self.portal.Entreprises.test_baty.Configuration.objectIds(['BatyCoefficient']))  )

    def testBaseTache(self):
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'base_tache'))

    def testBaseAffaire(self):
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'base_affaire') and len(self.portal.Entreprises.test_baty.base_affaire.objectIds(['BatyStock']))==1 and len(self.portal.Entreprises.test_baty.base_affaire.objectIds(['BatyFraisGeneraux']))==1)
                        
    
    def testBaseJournal(self):
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'base_journal'))

    def testBaseClient(self):
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'base_client'))

    
    def testBaseData(self):
        self.failUnless(hasattr(self.portal.Entreprises.test_baty,'Configuration'))
        
        self.failUnless(len(getattr(self.portal.Entreprises.test_baty,'Configuration').objectItems('BatyCoefficientStockage')) > 0)
        self.failUnless(len(getattr(self.portal.Entreprises.test_baty,'Configuration').objectItems('BatyFamille')) > 0)
        self.failUnless(len(getattr(self.portal.Entreprises.test_baty,'Configuration').objectItems('BatySecteur')) > 0)
        self.failUnless(len(getattr(self.portal.Entreprises.test_baty,'Configuration').objectItems('BatyCoefficient')) > 0)
        

    def getList(self):
        self.portal.Entreprises.test_baty.getListFamille()
        self.portal.Entreprises.test_baty.getListAffaire()
        self.portal.Entreprises.test_baty.getListClient()
        self.portal.Entreprises.test_baty.getListArticle()
        self.portal.Entreprises.test_baty.getListSalarie()
        self.portal.Entreprises.test_baty.getListTache()
        self.portal.Entreprises.test_baty.getListSecteur()
        self.portal.Entreprises.test_baty.getListCoefficient()
        self.portal.Entreprises.test_baty.getListCoefficient()
        self.portal.Entreprises.test_baty.getListPrime()
        
        


if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
