import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))
from Testing import ZopeTestCase
from Products.ArchBaty.tests import BatyTestCase



from Acquisition import aq_base


class TestCreateBatyEntreprise(BatyTestCase.BatyTestCase):

    
    def test_hasEntreprise( self ):

        site = self.getPortal()
        self.failUnless(hasattr(site, 'Entreprises'))
                        
    def test_createEntreprise(self):
        site =self.getPortal()
        self.login('BatyManager')
        site.Entreprises.invokeFactory(id='ebaty',type_name='BatyEntreprise')

    def test_create_article(self):
        site =self.getPortal()
        self.login('BatyManager')
        #print site.portal_membership.getAuthenticatedMember().getRoles()
        site.Entreprises.test_baty.base_article.invokeFactory(id='abaty',type_name='BatyArticle')

    def test_getObjFromUid(self):
        site =self.getPortal()
        self.login('BatyManager')
        entreprise=self.getEntreprise()

        print entreprise.getObjFromUid('base_affaire')
        print entreprise.getObjFromUid('aff_stock')
        print entreprise.getObjFromUid('base_article')
        self.failUnless(entreprise.getObjFromUid('base_article') is not None)


        self.failUnless(entreprise.getFraisGenerauxAffaire() is not None)
        self.failUnless(entreprise.getStockAffaire() is not None)
        
        entreprise.getDestination('BatyAffaire').invokeFactory(id='affaire1',type_name='BatyAffaire')
        
        self.failUnless(entreprise.getObjFromUid('affaire1') is not None)

        entreprise.getDestination('BatyArticle').invokeFactory(id='article1',type_name='BatyArticle')

        self.failUnless(entreprise.getObjFromUid('article1') is not None)



        entreprise.getDestination('BatyFamille').invokeFactory(id='famille1',type_name='BatyFamille')

        self.failUnless(entreprise.getObjFromUid('famille1') is not None)


        
        
    def test_name_article(self):
        site =self.getPortal()
        self.login('BatyManager')
        
        
        site.Entreprises.test_baty.base_article.invokeFactory(type_name='BatyArticle',id='article1')
        entreprise=self.portal.Entreprises.test_baty
        base_article=entreprise.base_article
        kw={'famille':entreprise.getFirstObjectForType('BatyFamille').UID(),'unite':'litre','coefficient':entreprise.getFirstObjectForType('BatyCoefficient').UID(),'prix':1.0,'code_comptable':4,'stock':1,'quantite':54.0}
        base_article.article1.update(**kw)
        base_article.article1.Title()
        #self.failUnless('Article' in base_article.article1.Title())

    
    def test_create_journal(self):
        site =self.getPortal()
        self.login('BatyManager')
        entreprise=self.getEntreprise()
        entreprise.base_journal.invokeFactory(id='testjournal', type_name='BatyJournalHeure')


if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
