#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase

## for functionnal test pdf report
import ZPublisher


def callMethod(br,callMethod):

    print br.getObject()," callMethod = ",callMethod," ", getattr(br.getObject(),callMethod)()


class TestDevis(BatyTestCase.BatyTestCase):

    
        
        
    def estOrder(self):
        self.login('PloneManager')
        base=self.getEntreprise().getDestination('BatyDevis')
        base.invokeFactory(type_name='BatyDevis',id='devis')
        base.devis.invokeFactory(type_name='BatySection',id='section1')
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit1')
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit2',order=5)
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit3')
        print base.devis.section1.getOrder()
        print base.devis.section1.produit1.getOrder()
        print base.devis.section1.produit2.getOrder()
        print base.devis.section1.produit3.getOrder()
        
    def estCreateBatyDevisObject(self):
        self.login('PloneManager')
        base=self.getEntreprise().getDestination('BatyDevis')
        base.invokeFactory(type_name='BatyDevis',id='devis')
        
        base.devis.invokeFactory(type_name='BatySection',id='section1')
       
        
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit1')
        

        base.devis.section1.produit1.invokeFactory(type_name='BatyLigneProduit',id='ligne1')

        
        

    def testCoefficient_vente(self):
        self.login('PloneManager')
        base=self.getEntreprise().getDestination('BatyDevis')
        base.invokeFactory(type_name='BatyDevis',id='devis',coefficient_vente=4.0,coefficient_marge=5.0)
        
        base.devis.invokeFactory(type_name='BatySection',id='section1')
        #print base.devis.section1.getCoefficient_vente()
        #print base.devis.section1.getCoefficient_marge()
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit1')
        #print base.devis.section1.produit1.getCoefficient_vente()
        #print base.devis.section1.produit1.getCoefficient_marge()
        self.failUnless( base.devis.section1.produit1.getCoefficient_vente() == 4.0
                         and base.devis.section1.getCoefficient_vente() == 4.0)


    def est_setup_property(self):
        self.login('PloneManager')
        base=self.getEntreprise().getDestination('BatyDevis')
        base.invokeFactory(type_name='BatyDevis',id='devis',coefficient_vente=4.0,coefficient_marge=5.0)
        base.devis.invokeFactory(type_name='BatySection',id='section1')
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit1')
        print "right slot ---" + str(base.devis.section1.produit1.getProperty('right_slots'))
        
    def estPrix(self):
        self.login('PloneManager')
        print "-----------------------     test prix -------------------------------"
        
        objs=self.create_setUpJournal()
        #print objs['ligneDevis1'].introspect()
        kw={'prix':20}
        objs['ligneDevis1'].update(**kw)
        #print objs['ligneDevis1'].introspect()
        print "-----------------------  fin  test prix -------------------------------" 
        
        

        

    

    def test_IBatyInterface(self):

        print '------------ debut test IBatyInterface -------------'
        self.login('PloneManager')

        ## on cree les devis
        objs=self.create_setUpJournal()
        
        

        
        brs=self.portal['portal_catalog'](meta_type=['BatyDevis','BatySection','BatyProduit','BatyLigneProduit','BatyLigneProduitHeure'])
        for br in brs:
            print br.getObject()
            callMethod(br,'getPrix')
            callMethod(br,'getPrixAchat')
            callMethod(br,'getPrixVente')
            callMethod(br,'getPrixClient')
            callMethod(br,'getMarge')
            callMethod(br,'getPrixTva')
            callMethod(br,'getCoefficient_tva')
            callMethod(br,'getNbHeure')
            
            callMethod(br,'getQuantite')
            
            
            
        print '------------ fin test_IBatyInterface -------------'



    def est_getSituation(self):
        print "---------- debut test getsituation -------------"
        objs=self.create_setUpJournal()
        brs=self.portal['portal_catalog'](meta_type=['BatyDevis'])
        for br in brs:
            print br.getObject().getSituation()
        print "---------- fin test getsituation -------------"
        

            
    def test_references(self):
        print "---------- debut test reference ----------------"
        objs=self.create_setUpJournal()
        
        devis=self.portal['portal_catalog'](meta_type=['BatyDevis'])[0]
        client=devis.getObject().getClient()
        to_mvts=self.portal['portal_catalog'](meta_type=['BatyLigneProduit','BatyLigneProduitHeure'])
        entreprise=self.getEntreprise()


        ## on cree l'affaire depuis le devis ###
        self.portal.baty_tool.create_affaire_from_devis(entreprise,client,'test_affaire',list_mvt=to_mvts)

        affaire=[x for x in  entreprise.base_affaire.objectValues() if x.Title() == 'test_affaire'][0]
        print affaire,devis
        affaire.addReference(devis.getObject(),"devis")
        print str(affaire.getRefs("devis"))

        

    def test_getResults(self):
        objs=self.create_setUpJournal()
        print "------------- test get results -----------------"
        brs=self.portal['portal_catalog'](meta_type=['BatyDevis','BatyProduit','BatyLigneProduit','BatyLigneProduitHeure'])

        
        for item in brs:
            print item.getObject().meta_type,item.getObject().Title(),item.getObject().getResults()

        print "------------ fin test get results ---------------"

        
        
        
    def test_getRealQuantite(self):
        objs=self.create_setUpJournal()
        print "------------- test real quantite -----------------"
        brs=self.portal['portal_catalog'](meta_type=['BatyDevis','BatySection','BatyProduit','BatyLigneProduit','BatyLigneProduitHeure'])

        
        for item in brs:
            print item.getObject().meta_type,item.getObject().Title(),item.getObject().getRealQuantite()

        print "------------ fin test get real quantite ---------------"  


    


    def test_getDevisElementsFamille(self):
        objs=self.create_setUpJournal()
        print "test_getDevisElementFamille"

        brs=self.portal['portal_catalog'](meta_type=['BatyDevis',])
        for br in brs:
            print br.getObject().getDevisElementsFamille()
        print "fin test_getDevisElementFamille"


    def test_getDevisElementsFamilleForReport(self):
        objs=self.create_setUpJournal()
        print "test_getDevisElementFamilleForReport"

        brs=self.portal['portal_catalog'](meta_type=['BatyDevis',])
        for br in brs:
            print br.getObject().getDevisElementsFamilleForReport()
        print "fin test_getDevisElementFamilleForReport"
        

    def test_getDevisElementPrix(self):
        objs=self.create_setUpJournal()
        brs=self.portal['portal_catalog'](meta_type=['BatyDevis',])
        print "test_getDevisElementPrix"

        ##Dans devis il y a un article Quantite = 10 prix =1
        ##et une tache DE qt 10 de prix 10
        ## le coeffiient de vente == 10
        ## le coefficient frais generaux == 10
        ## prix de revient == cequi coute a l'entreprise
        ## prix de revient de article1 (10+100)*1.1= 121.0
        ## normalement le prix vente produit 1 = (10 +100)*1.1*1.1 =133.1
        ## prix tva ===  140.4205
        ## prix produit 2 (meme produit que le precedent mais avec une quantite == 10  et une tva different
        ## 10*133.1 =1331.0
        ## prix tva 1331.0 * 1.196 =1591.876

        ## prix vente total = 1464.1
        ## prix ttc = 1732.2965
        
        for br in brs:
            print br.getObject()
            from Products.ArchBaty.baty_types.BatyDevis import getDevisElementPrix
            hash_prix=getDevisElementPrix(br.getObject())
            hash_prix=br.getObject().getDevisElements()
            hash_prix_detail=getDevisElementPrix(devis=br.getObject(),detail=1)
#            hash_prix_detail=br.getObject().getDevisElements()
            #print "x=",hash_prix[0][1]['prix'],"y = ", float(133.1)
            #print hash_prix[0][1]['prix']

        for item in hash_prix:
            print str(item)

        print "--------- detail -------"
        for item in hash_prix_detail:
            print str(item)


        

        
        print "fin test_getDevisElementPrix"

    # def test_setCoefficient(self):
#         self.login('PloneManager')
#         objs=self.create_setUpJournal()
#         devis=self.portal['baty_catalog'](meta_type=['BatyDevis'])[0]
#         devis.update(**{'coefficient':20.0})




            

    def test_create_affaire_from_devis(self):
        self.login('PloneManager')
        print "test_create_affaire_from_devis"
        
        objs=self.create_setUpJournal()
        devis=self.portal['portal_catalog'](meta_type=['BatyDevis'])[0]
        print "devis info result=",str(devis.getObject().getResults())
        
        client=devis.getObject().getClient()
        to_mvts=self.portal['portal_catalog'](meta_type=['BatyLigneProduit','BatyLigneProduitHeure'])
        entreprise=self.getEntreprise()


        ## on cree le devis ###
        self.portal.baty_tool.create_affaire_from_devis(entreprise,client,'test_affaire',list_mvt=to_mvts)
        #for (id,obj) in self.getEntreprise().getDestination('BatyAffaire').objectItems():
        #    print "affaire =",obj.introspect()
        #    for (id2,child) in obj.objectItems():
        #        try:
        #            print child.introspect()
        #        except:
        #            print child
        sum_prevu=0
        for item in self.getEntreprise().base_affaire.objectValues():
            
            if item.Title() == 'test_affaire':
                
                print "prix de vente ===" ,item.getPrix_vente()
                for mvt in item.objectValues():
                    print "prix prevu   =",mvt.getPrix_prevu()
                    sum_prevu+=mvt.getPrix_prevu()
                    print "quantite_prevu=",mvt.getQuantite_prevu()
            
                print "total ",sum_prevu
        #self.failUnless(len(afs) == 1)
        # for (id,obj) in self.getEntreprise().getDestination('BatyAffaire').objectItems():
        #             if obj.Title() == 'test_affaire':
        #                 print "j'ai trouver"
        #                 self.portal.baty_tool.add_devis_to_affaire(obj.UID(), list_mvt=to_mvts)
        
        #         print "-------------- apres ------------------------"
        #         for (id,obj) in self.getEntreprise().getDestination('BatyAffaire').objectItems():
        #             for (id2,child) in obj.objectItems():
        #                 try:
        #                     print child.introspect()
        #                 except:
        #                     print child
        #for obj in self.getEntreprise().getDestination('BatyAffaire').objectItems()[0][1]:
                                #   print obj.introspect()
        print "fin test_create_affaire_from_devis"
        
        
if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestDevis))
        return suite
