#/usr/bin/python


from xml.sax import ContentHandler
from xml.sax.saxlib import LexicalHandler
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
from xml.sax.handler import property_lexical_handler
#from Products.ArchBaty.baty_types.BatyReport import BatyReport

import re

class BatyReport:
    

    def __init__(self,id,title='',logo=None,header_left='',header_right='',draw_line=0,landscape=0):
        self.id=id

    def batyreport_p(self,txt):
        print '***** ajout p',txt

    def batyreport_pre(self,txt):
        print '***** ajout pre',txt

    def batyreport_header(self,txt):
        print '***** ajout header',txt

    def batyreport_page_break(self):
        print '***** ajout saut page'


    def batyreport_table(self,data=[]):
        print 'ajout table',str(data)


    def generate_report(self):
        print "on genere le rapport"
    
        
    
        
        
        


class PrmDocHandler(ContentHandler, LexicalHandler):


    def __init__(self):
        self.__content=''
        self.__args={}
        self.__method=''
        self.__data=[]
        self.document=''
        self.__cdata=False
        #self.__current_element=''
        

    def startElementNS(self, (uri, localname), qname, attrs):
        print uri,localname,qname,attrs
        for attr in attrs.keys():
            print "argument =",attr[1],'===',attrs[attr]
        method="start_"+localname
        if uri == 'http://www.batysoft.org/batyparaph':
            self.__content+='<%s>' % localname
        
        if hasattr(self,method):
            kw=dict([(str(x[1]),str(attrs.getValue(x))) for x in  attrs.getNames()])
            print str(kw)
            getattr(self,method)(kw)


        

    def endElementNS(self, (uri, localname), qname):
        method="end_"+localname
        if uri == 'http://www.batysoft.org/batyparaph':
            self.__content+='</%s>' % localname
        if hasattr(self,method):
            getattr(self,method)()
            self.__content=''

    def startCDATA(self):
        print "on est en CDATA"
        self.__cdata=True

    def endCDATA(self):
        print "on n'est plus en CDATA"
        self.__cdata=False
        
    def start_document(self,attrs):
        print "start_document"
        self.document=BatyReport(**attrs)

    def start_header(self,attrs):
        self.__method=self.document.batyreport_header
        self.__args=attrs

    def start_p(self,attrs):
        self.__method=self.document.batyreport_p
        self.__args=attrs


    def start_table(self,attrs):
        self.__method=self.document.batyreport_table
        self.__args=attrs
        self.__data=[]
        

    def start_tr(self,attrs):
        self.__data.append([])



    def start_td(self,attrs):
        return

    start_th=start_td

    def start_pre(self,attrs):
        self.__method=self.document.batyreport_pre
        self.__args=attrs
        


    def end_page_break(self,attrs):
        self.document.batyreport_page_break()

    
    
    def end_header(self):
        self.__method(txt=self.__content,**self.__args)
        
    def end_p(self):
        self.__method(txt=self.__content,**self.__args)
    

    def end_table(self):
        self.__method(data=self.__data,**self.__args)
        
        
    def end_document(self):
        self.document.generate_report()
        
        
    def end_tr(self):
        return

    

    def end_td(self):
        self.__data[len(self.__data)-1].append(self.__content)

    end_th=end_td

    def end_pre(self):
        self.__method(txt=self.__content,**self.__args)

    def characters(self, content):
        if self.__cdata:
            self.__content+=content
        else:
            if re.compile(".*\w.*").match(content):
                self.__content+=content
                
                

if __name__ == '__main__':
    print "-------------- debut ---------------------"
    dh = PrmDocHandler()
    parser =make_parser()
    parser.setFeature(feature_namespaces, 1)
    parser.setProperty(property_lexical_handler,dh)
    parser.setContentHandler(dh)
    import os
    print os.getcwd()
    f=open('in/toPrint.xml')
    parser.parse('./in/toPrint.xml')
    
