## Controller Python Script "baty_folder_copy"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Copy objects by uid
##

from Products.CMFPlone import transaction_note
ids=context.REQUEST.get('ids', [])
titles=[]
titles_and_ids=[]
objects=[]
real_ids=[]
status='failure'
message='Please select one or more items to delete.'
parent=None
for uid in ids:
    obj=context.getObjFromUid(uid)
    if parent is None:
        parent=obj.getParentNode()
        
    if obj is not None and parent == obj.getParentNode():
        titles.append(obj.title_or_id())
        titles_and_ids.append('copied %s (%s)' % (obj.title_or_id(), obj.getId()))

        real_ids.append(obj.getId())
        context.plone_log(real_ids)
    
if real_ids:
    status='success'
    message=', '.join(titles)+' has been copied.'
    transaction_note('Copied %s' % (', '.join(titles_and_ids)))
    #for obj in objects:
    context.plone_log(parent.title_or_id())
    REQUEST=context.REQUEST
    parent.manage_copyObjects(real_ids,REQUEST,REQUEST.RESPONSE)
    
            
if context.REQUEST.form.get('action_view',0):
    state.set(button='BatyView')
    

    
context.plone_log('data ' + str(context.cb_dataValid())) 

return state.set(status=status, portal_status_message=message,context=context)

