## Controller Python Script "baty_folder_delete"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Delete objects by uid
##

from Products.CMFPlone import transaction_note
ids=context.REQUEST.get('ids', [])
titles=[]
titles_and_ids=[]
objects=[]
status='failure'
message='Please select one or more items to delete.'

for uid in ids:
    obj=context.getObjFromUid(uid)
    
    

    
    references_obj=obj.getBRefs()
    if len(references_obj):
        ## l'objet est reference quelque part ===> impossible de le suprimmer
        message+='Impossible de supprimmer '+obj.title_or_id()+'. Cet objet est referenc dans les objets suivants :'+', '.join([x.Title() for x in references_obj])
        ids.remove(uid)
        
    else:
        titles.append(obj.title_or_id())
        titles_and_ids.append('%s (%s)' % (obj.title_or_id(), obj.getId()))
        objects.append(obj)
    
current_niv=len(context.getPhysicalPath())
redirect_to=context
if ids:
    status='success'
    message=', '.join(titles)+' has been deleted.'
    transaction_note('Deleted %s from %s' % (', '.join(titles_and_ids), context.absolute_url()))
    for obj in objects:
                    
        if obj is not None:
            p=obj.getParentNode()
            p.getPhysicalPath()
            niv=len(p.getPhysicalPath())
            if niv<current_niv:
                redirect_to=p
                current_niv=niv
            p.manage_delObjects(obj.getId())
            
#context.plone_log(context.REQUEST.form.get('BatyProduitLigne',0))
if context.REQUEST.form.get('BatyProduitLigne',0):
    state.set(button='BatyProduitLigne')
if context.REQUEST.form.get('BatyProduitLigneHeure',0):
    state.set(button='BatyProduitLigneHeure')
if context.REQUEST.form.get('BatyCoefficient',0):
    state.set(button='BatyCoefficient')
if context.REQUEST.form.get('BatyCoefficientStockage',0):
    state.set(button='BatyCoefficientStockage')
if context.REQUEST.form.get('BatySecteur',0):
    state.set(button='BatySecteur')
if context.REQUEST.form.get('action_view',0):
    state.set(button='BatyView')
    

    
#context.plone_log('button:' + state.button) 

return state.set(status=status, portal_status_message=message,context=redirect_to)

