###  Controller Python Script
#context.n = context.REQUEST.get('n')

# Optionally set the default next action (this can be overridden
# in the ZMI)

## do somethong with context

#state.setNextAction('redirect_to:string:view')

# Optionally pass a message to display to the user
catalog=context.portal_catalog
baty_tool=context.baty_tool
filter={'meta_type':['BatyLigneProduit','BatyLigneProduitHeure']}
list_elements_devis=context.baty_tool.listElementFromUid(context.UID(),catalog=catalog,filter=filter)

partition=[[context.UID(),list_elements_devis]]

context.plone_log('il y %d elements dans le devis %s' % (len(list_elements_devis),context.UID()))
context.plone_log('devis %s',[x.UID for x in list_elements_devis])
    

for item in context.REQUEST.get('ids'):
    if item!=context.UID():
        ## c'est deja fait
        list_elements=context.baty_tool.listElementFromUid(item,catalog=catalog,filter=filter)
        if len(list_elements):
            ## on supprimme les elements des partitions existantes
            i=0
            for element_partition in partition:
                context.plone_log('suppression dans %d %d' % (i,len(element_partition[1])))
                context.plone_log([  y.UID for y in list_elements ])
                new_list_elements_devis = [ x for x in element_partition[1] if x.UID not in [ y.UID for y in list_elements ]]
                context.plone_log('apres')
                ## maj de la partition, si la partition est vide alors on la supprime de la partition
                if len(new_list_elements_devis):
                    partition[i][1]=new_list_elements_devis
                else:
                    del partition[i]
                
                context.plone_log('suppression dans %d %d' % (i,len(element_partition[1])))
                i=i+1
            ## on rajoute le nouvel element
            partition+=[[item,list_elements]]


for element_partition in partition:
    ## maintenant on cree les affaire
    uid=element_partition[0]
    list_element=element_partition[1]
    if context.REQUEST['AcceptDevis_'+uid]['affaire']:
        ## on cree
        context.plone_log('il y %d elements dans la partition %s, creation affaire' %(len( element_partition[1]),element_partition[0]))
        ## on recupere l'entreprise par aquisition
        affaire=baty_tool.create_affaire_from_devis(entreprise=context.getEntreprise(),client_uid=context.getClient(),name=context.REQUEST['AcceptDevis_'+uid]['affaire'],list_mvt=list_element)
        affaire.addReference(context.getObjFromUid(uid),"devis")
    else:
        context.plone_log('il y %d elements dans la partition %s, ajout dans affaire'  % (len( element_partition[1]),element_partition[0]))
        affaire=baty_tool.add_devis_to_affaire(uid_affaire=context.REQUEST['AcceptDevis_'+uid]['saffaire'],list_mvt=list_element)
        affaire.addReference(context.getObjFromUid(uid),"devis")
        
    
    
    
        
#context.plone_log('il y %d elements dans le devis ' % (len(list_elements_devis),))
## c'est cool on passe la transition 
context.portal_workflow.doActionFor(context,'accepter',comment=context.REQUEST['comment'])

state.setKwargs({'portal_status_message':'Data Updated'})
return state

