#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase

class TestBatyTool(BatyTestCase.BatyTestCase):

    
        
    def test_listElementFromUid(self):
        baty_tool=self.portal.baty_tool
        brs=baty_tool.listElementFromUid('Configuration',filter={'portal_type':'BatyFamille'})
        self.assertEquals(len(brs),5)


    def test_getMetadataFromUid(self):
        baty_tool=self.portal.baty_tool
        meta=baty_tool.getMetadataFromUid('mat','Title')
        self.assertEquals(meta,'Materiaux')

    def test_getObjFromUid(self):
        baty_tool=self.portal.baty_tool
        obj=baty_tool.getObjFromUid('mat')
        self.assertEquals(obj.UID(),'mat')

    def test_getMetadataFromAttr(self):
        baty_tool=self.portal.baty_tool
        article_object=self.createDefaultArticle()
        
        value=baty_tool.getMetadataFromAttr(instance=article_object,attr='famille',meta='Title')
        self.failUnless(value is not None)
        
    def test_get_property(self):
        baty_tool=self.portal.baty_tool
        self.assertEquals(baty_tool.get_property('unite','kil'),'Killogramme')
        


if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestBatyTool))
        return suite
