#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase

class TestImportExport(BatyTestCase.BatyTestCase):

    
        

    def testIsAllowed(self):
        
        self.login('PloneManager')
        self.failUnless(hasattr(self.portal,'Entreprises'))
        Entreprise=self.getEntreprise()
        base_article=Entreprise.getDestination('BatyArticle')
        import os

        file=open('./in/article_id.csv')
        base_article.baty_import(file,'BatyArticle')


    def testImport(self):
        
        self.login('PloneManager')
        self.failUnless(hasattr(self.portal,'Entreprises'))
        Entreprise=self.getEntreprise()
        base_article=Entreprise.getDestination('BatyArticle')
        import os

        file=open('./in/article.csv')
        base_article.baty_import(file,'BatyArticle')
    

    def test_export(self):
        """tes an export of a baty base"""
        self.login('PloneManager')
        Entreprise=self.getEntreprise()
        base_article=Entreprise.getDestination('BatyArticle')
        csv=base_article.baty_export({'portal_type':['BatyArticle','BatyArticleFraisGeneraux','BatyArticleFraisStockage','BatyArticleCredit']},list_field=['id','Title','code_num','famille','quantite'])
        #print csv
#         base_article=Entreprise.getDestination('BatyArticle')
#         print base_article
#         print base_article.allowedContentTypes()
        
#         for item in base_article.allowedContentTypes() :
#             print item.Title()
#             obj=item.constructInstance(base_article, id='BatyArticle')
#             print obj




if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
