#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase
from Products.ArchBaty.baty_types.BatyReport import BatyReport





class PrmDocHandler(ContentHandler):

    def startElementNS(self, (uri, localname), qname, attrs):
        print uri,localname,qname,attrs

    def endElementNS(self, (uri, localname, qname)):
        print uri,localname,qname,attrs
                     
    


class TestSomeProduct(BatyTestCase.BatyTestCase):

    def testReport(self):
        
        self.login('PloneManager')
        
        br=BatyReport('test-report',landscape=1,header_right='baty rapport')
        
        br.batyreport_header("Baty Report")
        br.batyreport_p("test de paragraph")
        br.batyreport_table([['unddddd dd','deux','trois','quatre','cinq'], range(5),range(5),range(5),range(5)])
        br.batyreport_page_break()
        res=br.generate_report()
        fd=open('out/test_report.pdf','w')
        fd.write(br.getPdf_file())
        fd.close()

    def testWithoutGenerate(self):
        self.login('PloneManager')
         
        br=BatyReport('test-report',landscape=1,header_right='baty rapport')
        
        br.batyreport_header("Baty Report")
        br.batyreport_p("test de paragraph")
        br.batyreport_table([['unddddd dd','deux','trois','quatre','cinq'], range(5),range(5),range(5),range(5)])
        br.batyreport_page_break()
        
        fd=open('out/test_report_2.pdf','w')
        fd.write(br.getPdf_file())
        fd.close()
        
    def test2Generate(self):
        self.login('PloneManager')
         
        br=BatyReport('test-report',landscape=1,header_right='baty rapport')
         
        br.batyreport_header("Baty Report")
        br.batyreport_p("test de paragraph")
        br.batyreport_table([['unddddd dd','deux','trois','quatre','cinq'], range(5),range(5),range(5),range(5)])
        br.batyreport_page_break()
        
        fd=open('out/test_report_2_1.pdf','w')
        fd.write(br.getPdf_file())
        fd.close()
        br.batyreport_p("Ajout d'un nouveau paragraph")
        fd=open('out/test_report_2_2.pdf','w')
        fd.write(br.generate_report())
        fd.close()
        

    def testParsexml(self):
        
        
        # Create an instance of the handler classes
        dh = PrmDocHandler()
        parser =make_parser()
        parser.setFeature(feature_namespaces, 1)
        parser.setContentHandler(dh)
        f=open('out/toPrint.xml')
        parser.parseString(f.read())
        

        



if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
